create schema LogiTelcom;

create Table LogiTelcom.cells
(
    regionID int NOT NULL,
    towerID int NOT NULL,
    missing int NULL,
    bad int NULL,
    towername varchar(32) NULL,
    Latitude float NULL,
    Longitude float NULL,
    rdCoordinates varchar(2000) NULL
)
;
create Table LogiTelcom.concepts
(
    master varchar(32) NOT NULL,
    concept varchar(32) NULL,
    publication varchar(32) NULL,
    pubtype varchar(32) NULL,
    content varchar(128) NULL,
    timestamp datetime NULL,
    link varchar(64) NULL
)
;
create Table LogiTelcom.customersessions
(
    sessionid int NOT NULL,
    timestamp datetime NULL,
    account int NULL,
    cellsite varchar(10) NULL,
    service varchar(10) NULL,
    packetlossratio float NULL,
    jitter int NULL,
    latency int NULL,
    MOS float NULL,
    setuptime float NULL,
    RTT float NULL,
    bitrate int NULL,
    dropped varchar(3) NULL,
    blocked varchar(3) NULL,
    lattitude float NULL,
    longitude float NULL,
    phone varchar(32) NULL,
    location varchar(32) NULL
)
;
create Table LogiTelcom.kpiunits
(
    kpi varchar(32) NOT NULL,
    units varchar(32) NOT NULL,
    quality varchar(32) NOT NULL
)
;
create Table LogiTelcom.networkq
(
    time datetime NOT NULL,
    kpi varchar(32) NULL,
    service varchar(32) NULL,
    quality varchar(32) NULL,
    value real NULL,
    good int NULL
)
;
create Table LogiTelcom.regions
(
    ID int NOT NULL,
    market varchar(32) NULL,
    product varchar(32) NULL,
    rdCoordinates varchar(4000) NULL
)
;
create Table LogiTelcom.troubletickets
(
    ticketid varchar(32) NOT NULL,
    status varchar(32) NULL,
    severity int NULL,
    network varchar(32) NULL,
    location varchar(32) NULL,
    market varchar(32) NULL,
    timesubmitted datetime NULL,
    timeassigned datetime NULL,
    timeresolved datetime NULL,
    description varchar(128) NULL,
    customerimpact varchar(32) NULL
)
;
create Table LogiTelcom.wordcloud
(
    master varchar(32) NOT NULL,
    weight int NULL,
    sentiment varchar(32) NULL
)
;

create Table LogiTelcom.twitter
(
    handle varchar(32) NOT NULL,
    sentiment varchar(32) NULL,
    message varchar(128) NULL,
    timestamp datetime NULL,
    category varchar(32) NULL,
    row int NULL
)
;
