var gMapLoadInterval,refreshIntervalId,nIntervId,overlayCnt = 0,intervalTmr = 5000;
var PolyColorArray = ['#f8f6a5', '#a6c186', '#f0a19c', '#f4f1a4', '#f88e8a', '#f4f18b', '#fb704c', '#54dc3e', '#f50b0b', '#f0a410'];
var refreshIntervalTime = 30; //seconds
var regionBounds;
var regionOpacity = 0.6;
var weatherOpacity = 0.3;
var geoJSON;
var request;
var gettingData = false;
var historicalOverlay;
var lat = 39.1364522;
var lon = -84.6104411;
var openWeatherMapKey = "895ea3d4a206efb47e7f0586289a8a04";
var badCells=[],okayCells=[];
var mapID = "gmap";
/***********************************************************************************************************************************************/
/*START MARKET GEOCODING*/
/***********************************************************************************************************************************************/
var initMarket = function () {
    gMapLoadInterval = setInterval(function () {initMapOptions();}, 200);
},
initMapOptions = function () {
	if(typeof(rdGetGMapObject(mapID)) == 'undefined' || typeof(rdGetGMapObject(mapID).getBounds()) == 'undefined') {
		return;
	}
	else {
		clearInterval(gMapLoadInterval);
		if($('#showWeather').val() == '1') {
			initializeWeather();
		}
		fitAllBounds();
	}
},
startInverval = function () {
	if($('#showMarket').val() == '1') {
		startTimer();
		removeMarkers().done(updateMarkers());
	}
	if($('#showWeather').val() == '1') {
		animateOverlay(rdGetGMapObject(mapID));
	}
    $('.time', window.parent.document).html('Cell service simulation in progress!');
},
stopInverval = function () {
	clearInterval(refreshIntervalId);
	if($('#showWeather').val() == '1') {
		startOverlay(rdGetGMapObject(mapID));
	}
    $('.time', window.parent.document).html('Select Simulate to start refresh countdown.');
},
showRegionInfo = function (regionID) {
	$('#hiddenRegionID').val(regionID);
	$('#hiddenSimulateComponent').val('Cell');
	removeMarkers().done(showCells(regionID)); 	
	if($('#divBackToRegions').length)
		$('#divBackToRegions').removeClass('hidden');
},
GoBackToRegions = function () {
	$('#hiddenRegionID').val('');
	$('#hiddenSimulateComponent').val('Regions');
	removeMarkers().done(updateMarkers());
	$('#divBackToRegions').addClass('hidden');
	if($('#lblMapHeader', window.parent.document).length)
		$('#lblMapHeader', window.parent.document).html('Market');
},
startTimer = function () {
	//var initValue = refreshIntervalTime;
	//var display = $('.time', window.parent.document);
    refreshIntervalId = setInterval(function () {
		refreshBadTowers(rdGetGMapObject(mapID));
		/*if($('.popover', window.parent.document).length) {
			$('.popover', window.parent.document).find('#lblSimulateTimer').html('Realtime refresh countdown ' + refreshIntervalTime + ' seconds.');
		}
        display.html('Realtime refresh countdown ' + refreshIntervalTime + ' seconds.');
        if (--refreshIntervalTime < 0) {
			refreshIntervalTime = initValue;
        }*/
    }, 1000);
},
refreshMarkers = function () {
	removeMarkers().done(updateMarkers());
},
updateMarkers = function () {
	var sMapID = $('[id*="rdGoogleMap"]').find("div:first-child").attr('id');
	var spanMap = document.getElementById(sMapID)
	var mapContainer = Y.one('#' + sMapID);
	var map = rdGetGMapObject(mapID);
	var regionId = document.getElementById('hiddenRegionID').value;	
	var simulateComponent = document.getElementById('hiddenSimulateComponent').value;	
	
	if (simulateComponent == "Cell") {
		var cellTowers = $.ajax({
			url: 'rdTemplate/rdData.aspx?rdData=gmTowers&rdDataID=cells&regionID='+regionId,
			dataType:"json",
			async: false
		}).responseJSON;
			
		regionBounds = new google.maps.LatLngBounds();
		for (var i = 0; i < cellTowers['data'].length; i++) {
			initTowers(map, sMapID, cellTowers['data'][i])
		}
		map.fitBounds(regionBounds)
	}
	
	if (simulateComponent == "Regions") {
		var cellRegions = $.ajax({
			url: 'rdTemplate/rdData.aspx?rdData=gmTowers&rdDataID=regions',
			dataType:"json",
			async: false
		}).responseJSON;
		
		regionBounds = new google.maps.LatLngBounds();	
		for (var i = 0; i < cellRegions['data'].length; i++) {	
			initRegions(map, sMapID, cellRegions['data'][i])
		}
		map.fitBounds(regionBounds)
	}
	$('#centerLatlng').val(map.getCenter().lat()+','+map.getCenter().lng());
	refreshBadTowers(map);
},
initTowers = function (gMap, sMapID, cellTower) {
	if(cellTower['missing'] == '1' && Math.random() < 0.5) return;
	var arrayPoly = [];
	var coordinates = cellTower["rdCoordinates"].split(',0 ');
	var latLon;
	for(var p = 0; p < coordinates.length; p++) {
		var strLatLon = coordinates[p].split(',');
		if(strLatLon.length >= 2) {
			var lastLongLat = strLatLon[1];
			latLon = new google.maps.LatLng(strLatLon[1], strLatLon[0]);
			arrayPoly.push(latLon);
			regionBounds.extend(latLon); 
		}
	}
		
	var encodedPolygon = new google.maps.Polygon({
		paths: arrayPoly,
		strokeColor: '#83d5fb',
		strokeOpacity: regionOpacity,
		strokeWeight: parseInt(2),
		fillColor: '#9ac78f',
		fillOpacity: regionOpacity,
		map: gMap
	});
	encodedPolygon.isMarker = false
	
    google.maps.event.addListener(encodedPolygon, "click", function (point) {
		var infowindow = new google.maps.InfoWindow({ content: getInfoWindowHTML(cellTower) });
		infowindow.setPosition(point.latLng);
		infowindow.open(gMap);
		if($('#centerLatlng').val().length > 0) {
			var ltln = $('#centerLatlng').val().split(',');
			var myLatlng = new google.maps.LatLng(ltln[0], ltln[1]);
			google.maps.event.addListener(infowindow, 'closeclick', function () {
				gMap.setCenter(myLatlng); 
			});
		}
    });
	
	if(cellTower['bad'] == '1') 
		badCells.push(encodedPolygon);
	else 
		okayCells.push(encodedPolygon);
},
initRegions = function (gMap, sMapID, dataRegions) {
	var arrayPoly = [];
	var coordinates = [];
	coordinates = dataRegions["rdCoordinates"].split(',0 ');
	for(var p = 0; p < coordinates.length; p++) {
		var strLatLon = coordinates[p].split(',');
		if(strLatLon.length >= 2) {
			var latLon = new google.maps.LatLng(strLatLon[1], strLatLon[0]);
			arrayPoly.push(latLon);
			regionBounds.extend(latLon); 
		}
	}
	var encodedPolygon = new google.maps.Polygon({
		paths: arrayPoly,
		strokeColor: '#736f70',
		strokeOpacity: regionOpacity,
		strokeWeight: parseInt(2),
		fillColor: dataRegions["csc"],//PolyColorArray[Math.floor(Math.random()*PolyColorArray.length)],
		fillOpacity: regionOpacity,
		map: gMap
	});
	
	encodedPolygon.isMarker = false
	mrkToRemove.push(encodedPolygon);
	
	if(dataRegions['regionID']==0) 
		badCells.push(encodedPolygon);
	else 
		okayCells.push(encodedPolygon);
	
	
    google.maps.event.addListener(encodedPolygon, "click", function (point) {
		showRegionInfo(dataRegions['regionID']);
    });
},
refreshBadTowers = function (gMap) {
	for (var i = 0; i < badCells.length; i++) {
		var cellColor = Math.random() < 0.2 ? '#f4f1a4' : '#f0a19c';				//f4f1a4=Yellow; f0a19c=Red; 
		badCells[i].setOptions({fillColor: cellColor});
	}
	var colorTimerVal = 0.005;
	if (document.getElementById('hiddenSimulateComponent').value == "Regions") 
		colorTimerVal = 0.05;
		
	for (var i = 0; i < okayCells.length; i++) { 
		//slow down the random color state.  
		var cellColor = Math.random() < colorTimerVal ? '#f8f6a5' : '#9ac78f'; 				//f8f6a5=Yellow; 9ac78f=Green;
		okayCells[i].setOptions({fillColor: cellColor});
	}
},
cellTowerIcon = function () {
	var icon = new google.maps.MarkerImage()
	icon.url = "_SupportFiles/CellTower70-20.png"
	icon.size = new google.maps.Size(25, 30)
	icon.scaledSize = new google.maps.Size(25, 30)
	icon.anchor = new google.maps.Point(25 / 2, 30)
	return icon;
},
getInfoWindowHTML = function (cellTower) {
	var titleWidth = "60px";
	var elemMargin = "70px";
	var quality = 1;
    var infoWinUpd = "<dl class=\"dl-horizontal nowrap text-info\" style=\"width: 200px\">";
	if (typeof cellTower['region'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Region:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['region'] + "</dd>";
	if (typeof cellTower['towerID'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">TowerId:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['towerID'] + "</dd>";
	if (typeof cellTower['towername'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Name:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['towername'] + "</dd>";
	if (typeof cellTower['product'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Product:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['product'] + "</dd>";
	if (typeof cellTower['market'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Market:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['market'] + "</dd>";
	if (cellTower['csc'] == '#9AC78F') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Quality:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + 'Good' + "</dd>";
		else if (cellTower['csc'] == '#FF0000')
			infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Quality:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + 'Bad' + "</dd>";
		else if (cellTower['csc']== '#FFFF00')
			infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Quality:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + 'Poor' + "</dd>";
	/*if (typeof cellTower['bad'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Bad:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['bad'] + "</dd>";
	if (typeof cellTower['missing'] !== 'undefined') 
		infoWinUpd += "<dt style=\"width: "+ titleWidth +"\">Missing:</dt><dd style=\"margin-left: "+ elemMargin +"\">" + cellTower['missing'] + "</dd>";*/
	if (cellTower['csc'] == '#FF0000'){
		quality = 0;
	}
	else {
		quality = 1;
	}
	infoWinUpd += "</dl>";
	infoWinUpd += "<a href=\"JavaScript:void(0)\" onclick=\"showServiceDetails(" + cellTower['towerID'] + ",'" + cellTower['towername'] + "','" + cellTower['product'] + "','" + cellTower['market'] + "','" + quality + "');\" class=\"btn btn-warning btn-sm btn-block\" target=\"_blank\">View " + cellTower['towername'] + "</a>";
	return infoWinUpd;
},
removeMarkers = function () {
  	var r = $.Deferred();
	for(i=0; i<mrkToRemove.length; i++){
		mrkToRemove[i].setMap(null);
	}
	for(i=0; i<badCells.length; i++){
		badCells[i].setMap(null);
	}
	for(i=0; i<okayCells.length; i++){
		okayCells[i].setMap(null);
	}
	r.resolve();
	return r;
},
showCells = function(regionID) {
	var sMapID = $('[id*="rdGoogleMap"]').find("div:first-child").attr('id');
	var map = rdGetGMapObject(mapID);
	var cellTowers = $.ajax({
		url: 'rdTemplate/rdData.aspx?rdData=gmTowers&rdDataID=cells&regionID='+regionID,
		dataType:"json",
		async: false
	}).responseJSON;
	
	regionBounds = new google.maps.LatLngBounds();	
	for (var i = 0; i < cellTowers['data'].length; i++) {
		initTowers(map, sMapID, cellTowers['data'][i])
	}
	map.fitBounds(regionBounds)
	$('#centerLatlng').val(map.getCenter().lat()+','+map.getCenter().lng());
},
fitAllBounds = function() {
	var map = rdGetGMapObject(mapID);
	var regionsData = $.ajax({
		url: 'rdTemplate/rdData.aspx?rdData=gmTowers&rdDataID=regions&regionID=',
		dataType:"json",
		async: false
	}).responseJSON;
	
	var boundsByRegion = new google.maps.LatLngBounds();
	for (var i = 0; i < regionsData['data'].length; i++) {
		var coordinates = regionsData['data'][i]["rdCoordinates"].split(',0 ');
		for(var p = 0; p < coordinates.length; p++) {
			var strLatLon = coordinates[p].split(',');
			if(strLatLon.length >= 2) {
				boundsByRegion.extend(new google.maps.LatLng(strLatLon[1], strLatLon[0])); 
			}
		}
	}
	map.fitBounds(boundsByRegion)
	$('#centerLatlng').val(map.getCenter().lat()+','+map.getCenter().lng());
},
centerMap = function() {
	//called from serviceAssurance
	var ltln = $('#centerLatlng').val().split(',');
	var myLatlng = new google.maps.LatLng(ltln[0], ltln[1]);
	setTimeout(function(){
		rdGetGMapObject(mapID).setCenter(myLatlng); 
	}, 300);
	
},
centerMapOnRegion = function(regionID) {
	var map = rdGetGMapObject(mapID);
	var url='rdTemplate/rdData.aspx?rdData=gmTowers&rdDataID=cells&regionID='+regionID;
	var cellRegions = $.ajax({
		url: url,
		dataType:"json",
		async: false
	}).responseJSON;
	
	var regionBounds = new google.maps.LatLngBounds();
    var points = new Array();
	for (var i = 0; i < cellRegions['data'].length; i++) {
		var coordinates = [];
		coordinates = cellRegions['data'][i]["rdCoordinates"].split(',0 ');
		for(var p = 0; p < coordinates.length; p++) {
			var strLatLon = coordinates[p].split(',');
			if(strLatLon.length >= 2) {
				points = new google.maps.LatLng(strLatLon[1], strLatLon[0]);
				regionBounds.extend(points); 
			}
		}
		$('#lblMapHeader').html(cellRegions['data'][i]['product']);
	}		
	map.fitBounds(regionBounds);
	setTimeout(function(){
		$('#centerLatlng').val(map.getCenter().lat()+','+map.getCenter().lng());
	}, 300);
},    
showServiceDetails = function (towerID,towerName,product,market,quality) {
	var iframeUrl = encodeURI("rdPageAsync.aspx?rdReport=SubReports.ServiceDetails&CellName="+towerName+"&MarketName="+towerName+"&ProductType="+product+"&MarketName="+market+"&goodTower="+quality+"&rdSubReport=True");
	$('#rptServiceDetails', window.parent.document).attr('src', iframeUrl);
	if ($('#divServiceAssurance',window.parent.document).length) {
		$('#divServiceAssurance',window.parent.document).fadeOut().addClass('hidden');
		$('#divServiceDetails',window.parent.document).fadeIn(1500).removeClass('hidden');
	}
	else if ($('#modalServiceDetails',window.parent.document).length) {
    	$('body',window.parent.document).addClass('modal-open');
		$('#modalServiceDetails',window.parent.document).modal('show').on('hidden.bs.modal', function () {
			$('body').removeClass('modal-open');
		});
	}
},  
hideServiceDetails = function () {	
	if ($('#divServiceAssurance',window.parent.document).length){
		$('#divServiceDetails',window.parent.document).fadeOut().addClass('hidden');
		$('#divServiceAssurance',window.parent.document).fadeIn('slow').removeClass('hidden');
	}
},
getParameterByName = function (name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(window.parent.document.location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
};
/***********************************************************************************************************************************************/
/*END MARKET GEOCODING*/
/***********************************************************************************************************************************************/
/*START WEATHER*/
/***********************************************************************************************************************************************/
var mapBounds = {
	north: 43,
	south: 35,
	east: -70,
	west: -94
};
var overlayBounds = new google.maps.LatLngBounds(new google.maps.LatLng(mapBounds.south,mapBounds.west),new google.maps.LatLng(mapBounds.north,mapBounds.east));
var initializeWeather = function() {
	//military,nightVision,iovationMapDark,inturlam,inturlam2
	var MapStyle = document.getElementById('MapStyle').value;	
	var minZoomLevel = 6;
 	rdGetGMapObject(mapID).setOptions({draggable: false, minZoom: 6, scrollwheel: false, disableDoubleClickZoom: true, styles: window[MapStyle]});
	google.maps.event.addListener(rdGetGMapObject(mapID), 'idle', checkIfDataRequested);
	
	checkIfDataRequested(rdGetGMapObject(mapID));
	setTimeout(function(){ startOverlay(rdGetGMapObject(mapID)); }, 1000);
	initInfoWindow();
	centerMapOnRegion('');
},
checkIfDataRequested = function() {
	if($('#showWeather').val() != '1') {
		return;
	}
	while (gettingData === true) {
		request.abort();
		gettingData = false;
	}
	getCoords();
},
getCoords = function() {
	var bounds = rdGetGMapObject(mapID).getBounds();
	var NE = bounds.getNorthEast();
	var SW = bounds.getSouthWest();
	getWeather(NE.lat(), NE.lng(), SW.lat(), SW.lng());
},
getWeather = function(northLat, eastLng, southLat, westLng) {
	gettingData = true;
	northLat = northLat - .2;
	eastLng = eastLng + 1;
	southLat = southLat + .3;
	westLng = westLng + 1;
	var requestString = "http://api.openweathermap.org/data/2.5/box/city?bbox="
						+ westLng + "," + northLat + "," //left top
						+ eastLng + "," + southLat + "," //right bottom
						+ rdGetGMapObject(mapID).getZoom()
						+ "&cluster=yes&format=json"
						+ "&APPID=" + openWeatherMapKey;
	request = new XMLHttpRequest();
	request.onload = proccessResults;
	request.open("get", requestString, true);
	request.send();
},
proccessResults = function() {
	var results = JSON.parse(this.responseText);
	if (results.list.length > 0) {
		resetData();
		for (var i = 0; i < results.list.length; i++) {
			if(results.list[i].weather[0].icon != "01d")
		  		geoJSON.features.push(jsonToGeoJson(results.list[i]));
		}
		drawIcons(geoJSON);
	}
},
jsonToGeoJson = function (weatherItem) {
	var feature = {
		type: "Feature",
		properties: {
		city: weatherItem.name,
		weather: weatherItem.weather[0].main,
		temperature: weatherItem.main.temp,
		min: weatherItem.main.temp_min,
		max: weatherItem.main.temp_max,
		humidity: weatherItem.main.humidity,
		pressure: weatherItem.main.pressure,
		windSpeed: weatherItem.wind.speed,
		windDegrees: weatherItem.wind.deg,
		windGust: weatherItem.wind.gust,
		icon: "http://openweathermap.org/img/w/" + weatherItem.weather[0].icon  + ".png",
		coordinates: [weatherItem.coord.lon, weatherItem.coord.lat]
	  },
	  geometry: {
		type: "Point",
		coordinates: [weatherItem.coord.lon, weatherItem.coord.lat]
	  }
	};
	// Set the custom marker icon
	rdGetGMapObject(mapID).data.setStyle(function(feature) {
	  return {
		icon: {
		  url: feature.getProperty('icon'),
		  anchor: new google.maps.Point(25, 25)
		}
	  };
	});
	// returns object
	return feature;
},
drawIcons = function (weather) {
	rdGetGMapObject(mapID).data.addGeoJson(geoJSON);
	// Set the flag to finished
	gettingData = false;
},
resetData = function () {
	geoJSON = {
		type: "FeatureCollection",
		features: []
	};
	rdGetGMapObject(mapID).data.forEach(function(feature) {
		rdGetGMapObject(mapID).data.remove(feature);
	});
},
startOverlay = function () {
	clearOverlay();
	historicalOverlay = new USGSOverlay(overlayBounds, '_SupportFiles/weather-' + Math.floor(Math.random() * 6) + '.gif', rdGetGMapObject(mapID));
	overlayCnt =  overlayCnt + 1;
},
animateOverlay = function (gmap) {
	clearInterval(nIntervId); 
	overlayCnt = 0;
	clearOverlay();
	historicalOverlay = new USGSOverlay(overlayBounds, '_SupportFiles/weather.gif', gmap);
},
initInfoWindow = function () {
	var infowindow = new google.maps.InfoWindow();
	rdGetGMapObject(mapID).data.addListener('click', function(event) {
	  infowindow.setContent(
	   "<img src=" + event.feature.getProperty("icon") + ">"
	   + "<br /><strong>" + event.feature.getProperty("city") + "</strong>"
	   + "<br />" + event.feature.getProperty("temperature") + "&deg;C"
	   + "<br />" + event.feature.getProperty("weather")
	   );
	  infowindow.setOptions({
		  position:{
			lat: event.latLng.lat(),
			lng: event.latLng.lng()
		  },
		  pixelOffset: {
			width: 0,
			height: -15
		  }
		});
	  infowindow.open(rdGetGMapObject(mapID));
	});
	if($('#centerLatlng').val().length > 0) {
		var ltln = $('#centerLatlng').val().split(',');
		var myLatlng = new google.maps.LatLng(ltln[0], ltln[1]);
		google.maps.event.addListener(infowindow, 'closeclick', function () {
			rdGetGMapObject(mapID).setCenter(myLatlng); 
		});
	}
},
clearOverlay = function () {
	if(historicalOverlay != null && historicalOverlay !== undefined) {
		historicalOverlay.setMap(null);  
		historicalOverlay = null;  
	}
};
/***********************************************************************************************************************************************/
/*END WEATHER*/
/***********************************************************************************************************************************************/
/*START CUSTOM OVERLAY FUNCTIONS: these should never change*/
/***********************************************************************************************************************************************/
USGSOverlay.prototype = new google.maps.OverlayView();
/** @constructor */
function USGSOverlay(bounds, image, map) {

  // Initialize all properties.
  this.bounds_ = bounds;
  this.image_ = image;
  this.map_ = map;

  // Define a property to hold the image's div. We'll
  // actually create this div upon receipt of the onAdd()
  // method so we'll leave it null for now.
  this.div_ = null;

  // Explicitly call setMap on this overlay.
  this.setMap(map);
}
 
USGSOverlay.prototype.onAdd = function() {
	var div = document.createElement('div');
	div.style.borderStyle = 'none';
	div.style.borderWidth = '0px';
	div.style.position = 'absolute';
	div.style.opacity = weatherOpacity;
	
	// Create the img element and attach it to the div.
	var img = document.createElement('img');
	img.src = this.image_;
	img.style.width = '100%';
	img.style.height = '100%';
	img.style.position = 'absolute';
	div.appendChild(img);
	
	this.div_ = div;

	// Add the element to the "overlayLayer" pane.
	var panes = this.getPanes();
	panes.overlayLayer.appendChild(div);
};

USGSOverlay.prototype.draw = function() {

	// We use the south-west and north-east
	// coordinates of the overlay to peg it to the correct position and size.
	// To do this, we need to retrieve the projection from the overlay.
	var overlayProjection = this.getProjection();
	var sw = overlayProjection.fromLatLngToDivPixel(this.bounds_.getSouthWest());
  	var ne = overlayProjection.fromLatLngToDivPixel(this.bounds_.getNorthEast());
	
	// Resize the image's div to fit the indicated dimensions.
	var div = this.div_;
	div.style.left = sw.x + 'px';
	div.style.top = ne.y + 'px';
	div.style.width = (ne.x - sw.x) + 'px';
	div.style.height = (sw.y - ne.y) + 'px';
};

USGSOverlay.prototype.onRemove = function() {
  this.div_.parentNode.removeChild(this.div_);
  this.div_ = null;
};
/***********************************************************************************************************************************************/
/*END CUSTOM OVERLAY FUNCTIONS*/
/***********************************************************************************************************************************************/