// add a single randomised point to a time series chart, and the threshold
// varies the randomised point by a factor 1+/-(delta/2)

function updateChart(chartID, series1, initVal, series2, threshold, delta, good, sign) {
	delta = (typeof delta==='undefined')?0.2:delta;
	good = (typeof good==='undefined')?1:good;
        sign = (typeof sign==='undefined')?1:sign;
  setInterval( 
      function() {
        // get the ChartCanvasObject
        var chartCanvasObject = rdGetChartCanvasObject(chartID);
        var val;        
        if (good == 1) 
        {
         val = initVal*(1. +(delta*(Math.random()-0.5)));
        }
        else if (good == 0)
        {
          val = initVal*(1. + (3.*sign*delta*Math.random()));
        }
        if (val < 0.) { val = 0.01; }
        var d = new Date();
        // bug in API - it adds on the timezone, so take it out.
        d -= (d.getTimezoneOffset()*60*1000);
				
        // Create the data object for the random point 
        var myData = [];
        myData.push({
          x: d
          ,y: val
        });
       
        var chartOptions = {
          chart: {}
         ,series: [{
             id: series1,
             data: myData
             }]
        };
		
		// Create the data object for the threshold 
        var thresholdPoint = [];
        thresholdPoint.push({
          x: d
          ,y: threshold
        });
        
        var chartOptions2 = {
          chart: {}
         ,series: [{
             id: series2,
             data: thresholdPoint
             }]
        };

        // double check the ChartCanvasObject still exists. 
        if (chartCanvasObject !== null) {
          // console.log("Appending Data to chart: " + chartCanvasObject.id + ' values: ' + JSON.stringify(chartOptions));
          // Append the data. 
          chartCanvasObject.rdSetChartData(chartOptions, 'AppendData', 30);
		  chartCanvasObject.rdSetChartData(chartOptions2, 'AppendData', 30);
        }
      }, 2000); 
}
